/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	属性変更 複製先クラス
//		変更履歴
//			2004.07.21 新規作成 A.Shimoma
//							
//
package jp.co.ntt.lms.xmo.Lo;

import java.sql.SQLException;
import java.util.Hashtable;

import jp.co.ntt.lms.lo.LOException;
import jp.co.ntt.lms.xmo.XMOException;
import jp.co.ntt.lms.xmo.util.DebugLog;

/**
 * 
 * このクラスは属性変更対象LOの他参照(同リアルLOID)があり、
 * 且つ属性変更対象LOのLOIDとリアルLOIDが同IDでない場合に実行するクラスです。
 * 
 * @author A.Shimoma
 *  
 */
public class ChangeTypeReferenceLo extends ChangeTypeAbstract {

	/**
	 * コンストラクタ
	 *  
	 */
	public ChangeTypeReferenceLo() {
	}

	/**
	 * LOテーブルの更新を行います。
	 * 
	 * 属性変更対象LOのリアルLOIDをLOIDと同値し、 LOTypeをコンテナ｢0｣で更新を行います。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeLoAction()
	 */
	void changeLoAction() throws XMOException {

		putLoTableData( loID, loID, CONTAINER_TYPE, condition );

	}

	/**
	 * ログセッション情報変更アクションメソッド。 このクラスでは実装なし。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeLoLogSessionAction()
	 */
	void changeLoLogSessionAction() {
	}

	/**
	 * 共通ログの登録を行います。
	 * 
	 * 参照LO(リアルLOID)の共通ログレコードをコピーし、
	 * 属性変更対象LOのLOIDで更新します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeLoLogAction()
	 */
	void changeLoLogAction() throws XMOException {

		try{

			// 共通ログ情報を取得し、属性変更対象LOのLOIDで登録し直します。
			objLogUtil.changeType( realLoID, loID, objDataAccess );

		} catch ( LOException se ){
			DebugLog.write( this.getClass(), se, DebugLog.HIGHT );
			throw new XMOException( getMessageData( DB_ERR ) );
		}
	}

	/**
	 * 評価情報変更アクションメソッド。 このクラスでは実装なし。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeEvaluteAction()
	 */
	void changeEvaluteAction() {
	}

	/**
	 * 更新履歴テーブルへの登録を行います。
	 * 
	 * 参照LO(リアルLOID)の更新履歴レコードをコピーし、
	 * 属性変更対象LOのLOIDで更新します。
	 * 最後に属性変更分の新規レコードを登録します。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeLoHistoryAction()
	 */
	void changeLoHistoryAction() throws XMOException {

		try{

			// 属性変更前の履歴を引き継ぐ(該当LOIDデータを登録)
			Hashtable htbChangeParam = new Hashtable();

			htbChangeParam.put( LOGIN_USER_ID, userID );
			htbChangeParam.put( REAL_LOID, realLoID );
			htbChangeParam.put( LO_ID, loID );
			// 属性変更対象LOIDのリアルLOIDを元に属性変更対象LOIDで更新
			objLoDataAccess.ChangeTypeHistory( htbChangeParam, objDataAccess );
			// ハッシュのキー｢REAL_LOID｣の値を書き換えたいので
			// 一応ハッシュから削除
			htbChangeParam.remove( REAL_LOID );
			htbChangeParam.put( REAL_LOID, loID );
			// 属性変更対象LOIDをキーに現在日付を挿入
			objLoDataAccess.insertHistoryAction( htbChangeParam, objDataAccess );

		} catch ( SQLException se ){
			DebugLog.write( this.getClass(), se, DebugLog.HIGHT );
			throw new XMOException( getMessageData( DB_ERR ) );
		}
	}

	/**
	 * 個別ログ情報変更アクションメソッド。 このクラスでは実装なし。
	 *
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeIndividualLogAction()
	 */
	void changeIndividualLogAction() {
	}

	/**
	 * 各LO個別情報変更アクションメソッド。 このクラスでは実装なし。
	 * 
	 * @see jp.co.ntt.lms.xmo.Lo.ChangeTypeAbstract#changeOriginalLoAction()
	 */
	void changeOriginalLoAction() {
	}

}